Index: q931.c
===================================================================
--- q931.c	(revision 388)
+++ q931.c	(working copy)
@@ -3332,6 +3332,7 @@
 		pri->ev.ring.progressmask = c->progressmask;
 		return Q931_RES_HAVEEVENT;
 	case Q931_ALERTING:
+pri_message (pri, "AIT:::: Alerting\n");
 		if (c->newcall) {
 			q931_release_complete(pri,c,PRI_CAUSE_INVALID_CALL_REFERENCE);
 			break;
@@ -3388,6 +3389,8 @@
 #endif
 		return Q931_RES_HAVEEVENT;
 	case Q931_PROGRESS:
+pri_message (pri, "AIT:::: Progress\n");
+pri_message (pri, "AIT:::: Progress indicator %i\n", ie->data[1] & 0x7f);
 		if (missingmand) {
 			q931_status(pri, c, PRI_CAUSE_MANDATORY_IE_MISSING);
 			q931_destroycall(pri, c->cr);
@@ -3395,6 +3398,24 @@
 		}
 		pri->ev.e = PRI_EVENT_PROGRESS;
 		pri->ev.proceeding.cause = c->cause;
+	        if ((ie->data[1] & 0x7f) == Q931_PROG_CALLED_NOT_ISDN)
+		{
+pri_message (pri, "AIT:::: Progress--Alerting\n");
+			if (c->newcall) {
+				q931_release_complete(pri,c,PRI_CAUSE_INVALID_CALL_REFERENCE);
+				break;
+			}
+			UPDATE_OURCALLSTATE(pri, c, Q931_CALL_STATE_CALL_DELIVERED);
+			c->peercallstate = Q931_CALL_STATE_CALL_RECEIVED;
+			pri->ev.e = PRI_EVENT_RINGING;
+			pri->ev.ringing.channel = c->channelno | (c->ds1no << 8) | (c->ds1explicit << 16);
+			pri->ev.ringing.cref = c->cr;
+			pri->ev.ringing.call = c;
+			pri->ev.ringing.progress = c->progress;
+			pri->ev.ringing.progressmask = c->progressmask;
+			libpri_copy_string(pri->ev.ringing.useruserinfo, c->useruserinfo, sizeof(pri->ev.ringing.useruserinfo));
+			c->useruserinfo[0] = '\0';
+		}
 		/* Fall through */
 	case Q931_CALL_PROCEEDING:
 		if (c->newcall) {
